# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class NvmfSubsystem(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'bps': 'int',
        'bps_max': 'int',
        'bps_max_length': 'int',
        'bps_rd': 'int',
        'bps_rd_max': 'int',
        'bps_rd_max_length': 'int',
        'bps_wr': 'int',
        'bps_wr_max': 'int',
        'bps_wr_max_length': 'int',
        'cluster': 'NestedCluster',
        'description': 'str',
        'entity_async_status': 'EntityAsyncStatus',
        'external_use': 'bool',
        'id': 'str',
        'internal': 'bool',
        'io_size': 'int',
        'iops': 'int',
        'iops_max': 'int',
        'iops_max_length': 'int',
        'iops_rd': 'int',
        'iops_rd_max': 'int',
        'iops_rd_max_length': 'int',
        'iops_wr': 'int',
        'iops_wr_max': 'int',
        'iops_wr_max_length': 'int',
        'ip_whitelist': 'str',
        'labels': 'list[NestedLabel]',
        'local_id': 'str',
        'name': 'str',
        'namespace_groups': 'list[NestedNamespaceGroup]',
        'namespaces': 'list[NestedNvmfNamespace]',
        'nqn_name': 'str',
        'nqn_whitelist': 'str',
        'policy': 'NvmfSubsystemPolicyType',
        'replica_num': 'int',
        'stripe_num': 'int',
        'stripe_size': 'int',
        'thin_provision': 'bool'
    }

    attribute_map = {
        'bps': 'bps',
        'bps_max': 'bps_max',
        'bps_max_length': 'bps_max_length',
        'bps_rd': 'bps_rd',
        'bps_rd_max': 'bps_rd_max',
        'bps_rd_max_length': 'bps_rd_max_length',
        'bps_wr': 'bps_wr',
        'bps_wr_max': 'bps_wr_max',
        'bps_wr_max_length': 'bps_wr_max_length',
        'cluster': 'cluster',
        'description': 'description',
        'entity_async_status': 'entityAsyncStatus',
        'external_use': 'external_use',
        'id': 'id',
        'internal': 'internal',
        'io_size': 'io_size',
        'iops': 'iops',
        'iops_max': 'iops_max',
        'iops_max_length': 'iops_max_length',
        'iops_rd': 'iops_rd',
        'iops_rd_max': 'iops_rd_max',
        'iops_rd_max_length': 'iops_rd_max_length',
        'iops_wr': 'iops_wr',
        'iops_wr_max': 'iops_wr_max',
        'iops_wr_max_length': 'iops_wr_max_length',
        'ip_whitelist': 'ip_whitelist',
        'labels': 'labels',
        'local_id': 'local_id',
        'name': 'name',
        'namespace_groups': 'namespace_groups',
        'namespaces': 'namespaces',
        'nqn_name': 'nqn_name',
        'nqn_whitelist': 'nqn_whitelist',
        'policy': 'policy',
        'replica_num': 'replica_num',
        'stripe_num': 'stripe_num',
        'stripe_size': 'stripe_size',
        'thin_provision': 'thin_provision'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """NvmfSubsystem - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._bps = None
        self._bps_max = None
        self._bps_max_length = None
        self._bps_rd = None
        self._bps_rd_max = None
        self._bps_rd_max_length = None
        self._bps_wr = None
        self._bps_wr_max = None
        self._bps_wr_max_length = None
        self._cluster = None
        self._description = None
        self._entity_async_status = None
        self._external_use = None
        self._id = None
        self._internal = None
        self._io_size = None
        self._iops = None
        self._iops_max = None
        self._iops_max_length = None
        self._iops_rd = None
        self._iops_rd_max = None
        self._iops_rd_max_length = None
        self._iops_wr = None
        self._iops_wr_max = None
        self._iops_wr_max_length = None
        self._ip_whitelist = None
        self._labels = None
        self._local_id = None
        self._name = None
        self._namespace_groups = None
        self._namespaces = None
        self._nqn_name = None
        self._nqn_whitelist = None
        self._policy = None
        self._replica_num = None
        self._stripe_num = None
        self._stripe_size = None
        self._thin_provision = None
        self.discriminator = None

        self.bps = kwargs.get("bps", None)
        self.bps_max = kwargs.get("bps_max", None)
        self.bps_max_length = kwargs.get("bps_max_length", None)
        self.bps_rd = kwargs.get("bps_rd", None)
        self.bps_rd_max = kwargs.get("bps_rd_max", None)
        self.bps_rd_max_length = kwargs.get("bps_rd_max_length", None)
        self.bps_wr = kwargs.get("bps_wr", None)
        self.bps_wr_max = kwargs.get("bps_wr_max", None)
        self.bps_wr_max_length = kwargs.get("bps_wr_max_length", None)
        if "cluster" in kwargs:
            self.cluster = kwargs["cluster"]
        if "description" in kwargs:
            self.description = kwargs["description"]
        self.entity_async_status = kwargs.get("entity_async_status", None)
        if "external_use" in kwargs:
            self.external_use = kwargs["external_use"]
        if "id" in kwargs:
            self.id = kwargs["id"]
        if "internal" in kwargs:
            self.internal = kwargs["internal"]
        self.io_size = kwargs.get("io_size", None)
        self.iops = kwargs.get("iops", None)
        self.iops_max = kwargs.get("iops_max", None)
        self.iops_max_length = kwargs.get("iops_max_length", None)
        self.iops_rd = kwargs.get("iops_rd", None)
        self.iops_rd_max = kwargs.get("iops_rd_max", None)
        self.iops_rd_max_length = kwargs.get("iops_rd_max_length", None)
        self.iops_wr = kwargs.get("iops_wr", None)
        self.iops_wr_max = kwargs.get("iops_wr_max", None)
        self.iops_wr_max_length = kwargs.get("iops_wr_max_length", None)
        if "ip_whitelist" in kwargs:
            self.ip_whitelist = kwargs["ip_whitelist"]
        self.labels = kwargs.get("labels", None)
        if "local_id" in kwargs:
            self.local_id = kwargs["local_id"]
        if "name" in kwargs:
            self.name = kwargs["name"]
        self.namespace_groups = kwargs.get("namespace_groups", None)
        self.namespaces = kwargs.get("namespaces", None)
        if "nqn_name" in kwargs:
            self.nqn_name = kwargs["nqn_name"]
        if "nqn_whitelist" in kwargs:
            self.nqn_whitelist = kwargs["nqn_whitelist"]
        if "policy" in kwargs:
            self.policy = kwargs["policy"]
        if "replica_num" in kwargs:
            self.replica_num = kwargs["replica_num"]
        if "stripe_num" in kwargs:
            self.stripe_num = kwargs["stripe_num"]
        if "stripe_size" in kwargs:
            self.stripe_size = kwargs["stripe_size"]
        if "thin_provision" in kwargs:
            self.thin_provision = kwargs["thin_provision"]

    @property
    def bps(self):
        """Gets the bps of this NvmfSubsystem.  # noqa: E501


        :return: The bps of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps

    @bps.setter
    def bps(self, bps):
        """Sets the bps of this NvmfSubsystem.


        :param bps: The bps of this NvmfSubsystem.  # noqa: E501
        :type bps: int
        """

        self._bps = bps

    @property
    def bps_max(self):
        """Gets the bps_max of this NvmfSubsystem.  # noqa: E501


        :return: The bps_max of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_max

    @bps_max.setter
    def bps_max(self, bps_max):
        """Sets the bps_max of this NvmfSubsystem.


        :param bps_max: The bps_max of this NvmfSubsystem.  # noqa: E501
        :type bps_max: int
        """

        self._bps_max = bps_max

    @property
    def bps_max_length(self):
        """Gets the bps_max_length of this NvmfSubsystem.  # noqa: E501


        :return: The bps_max_length of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_max_length

    @bps_max_length.setter
    def bps_max_length(self, bps_max_length):
        """Sets the bps_max_length of this NvmfSubsystem.


        :param bps_max_length: The bps_max_length of this NvmfSubsystem.  # noqa: E501
        :type bps_max_length: int
        """

        self._bps_max_length = bps_max_length

    @property
    def bps_rd(self):
        """Gets the bps_rd of this NvmfSubsystem.  # noqa: E501


        :return: The bps_rd of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_rd

    @bps_rd.setter
    def bps_rd(self, bps_rd):
        """Sets the bps_rd of this NvmfSubsystem.


        :param bps_rd: The bps_rd of this NvmfSubsystem.  # noqa: E501
        :type bps_rd: int
        """

        self._bps_rd = bps_rd

    @property
    def bps_rd_max(self):
        """Gets the bps_rd_max of this NvmfSubsystem.  # noqa: E501


        :return: The bps_rd_max of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_rd_max

    @bps_rd_max.setter
    def bps_rd_max(self, bps_rd_max):
        """Sets the bps_rd_max of this NvmfSubsystem.


        :param bps_rd_max: The bps_rd_max of this NvmfSubsystem.  # noqa: E501
        :type bps_rd_max: int
        """

        self._bps_rd_max = bps_rd_max

    @property
    def bps_rd_max_length(self):
        """Gets the bps_rd_max_length of this NvmfSubsystem.  # noqa: E501


        :return: The bps_rd_max_length of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_rd_max_length

    @bps_rd_max_length.setter
    def bps_rd_max_length(self, bps_rd_max_length):
        """Sets the bps_rd_max_length of this NvmfSubsystem.


        :param bps_rd_max_length: The bps_rd_max_length of this NvmfSubsystem.  # noqa: E501
        :type bps_rd_max_length: int
        """

        self._bps_rd_max_length = bps_rd_max_length

    @property
    def bps_wr(self):
        """Gets the bps_wr of this NvmfSubsystem.  # noqa: E501


        :return: The bps_wr of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_wr

    @bps_wr.setter
    def bps_wr(self, bps_wr):
        """Sets the bps_wr of this NvmfSubsystem.


        :param bps_wr: The bps_wr of this NvmfSubsystem.  # noqa: E501
        :type bps_wr: int
        """

        self._bps_wr = bps_wr

    @property
    def bps_wr_max(self):
        """Gets the bps_wr_max of this NvmfSubsystem.  # noqa: E501


        :return: The bps_wr_max of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_wr_max

    @bps_wr_max.setter
    def bps_wr_max(self, bps_wr_max):
        """Sets the bps_wr_max of this NvmfSubsystem.


        :param bps_wr_max: The bps_wr_max of this NvmfSubsystem.  # noqa: E501
        :type bps_wr_max: int
        """

        self._bps_wr_max = bps_wr_max

    @property
    def bps_wr_max_length(self):
        """Gets the bps_wr_max_length of this NvmfSubsystem.  # noqa: E501


        :return: The bps_wr_max_length of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._bps_wr_max_length

    @bps_wr_max_length.setter
    def bps_wr_max_length(self, bps_wr_max_length):
        """Sets the bps_wr_max_length of this NvmfSubsystem.


        :param bps_wr_max_length: The bps_wr_max_length of this NvmfSubsystem.  # noqa: E501
        :type bps_wr_max_length: int
        """

        self._bps_wr_max_length = bps_wr_max_length

    @property
    def cluster(self):
        """Gets the cluster of this NvmfSubsystem.  # noqa: E501


        :return: The cluster of this NvmfSubsystem.  # noqa: E501
        :rtype: NestedCluster
        """
        return self._cluster

    @cluster.setter
    def cluster(self, cluster):
        """Sets the cluster of this NvmfSubsystem.


        :param cluster: The cluster of this NvmfSubsystem.  # noqa: E501
        :type cluster: NestedCluster
        """
        if self.local_vars_configuration.client_side_validation and cluster is None:  # noqa: E501
            raise ValueError("Invalid value for `cluster`, must not be `None`")  # noqa: E501

        self._cluster = cluster

    @property
    def description(self):
        """Gets the description of this NvmfSubsystem.  # noqa: E501


        :return: The description of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NvmfSubsystem.


        :param description: The description of this NvmfSubsystem.  # noqa: E501
        :type description: str
        """
        if self.local_vars_configuration.client_side_validation and description is None:  # noqa: E501
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def entity_async_status(self):
        """Gets the entity_async_status of this NvmfSubsystem.  # noqa: E501


        :return: The entity_async_status of this NvmfSubsystem.  # noqa: E501
        :rtype: EntityAsyncStatus
        """
        return self._entity_async_status

    @entity_async_status.setter
    def entity_async_status(self, entity_async_status):
        """Sets the entity_async_status of this NvmfSubsystem.


        :param entity_async_status: The entity_async_status of this NvmfSubsystem.  # noqa: E501
        :type entity_async_status: EntityAsyncStatus
        """

        self._entity_async_status = entity_async_status

    @property
    def external_use(self):
        """Gets the external_use of this NvmfSubsystem.  # noqa: E501


        :return: The external_use of this NvmfSubsystem.  # noqa: E501
        :rtype: bool
        """
        return self._external_use

    @external_use.setter
    def external_use(self, external_use):
        """Sets the external_use of this NvmfSubsystem.


        :param external_use: The external_use of this NvmfSubsystem.  # noqa: E501
        :type external_use: bool
        """
        if self.local_vars_configuration.client_side_validation and external_use is None:  # noqa: E501
            raise ValueError("Invalid value for `external_use`, must not be `None`")  # noqa: E501

        self._external_use = external_use

    @property
    def id(self):
        """Gets the id of this NvmfSubsystem.  # noqa: E501


        :return: The id of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NvmfSubsystem.


        :param id: The id of this NvmfSubsystem.  # noqa: E501
        :type id: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def internal(self):
        """Gets the internal of this NvmfSubsystem.  # noqa: E501


        :return: The internal of this NvmfSubsystem.  # noqa: E501
        :rtype: bool
        """
        return self._internal

    @internal.setter
    def internal(self, internal):
        """Sets the internal of this NvmfSubsystem.


        :param internal: The internal of this NvmfSubsystem.  # noqa: E501
        :type internal: bool
        """
        if self.local_vars_configuration.client_side_validation and internal is None:  # noqa: E501
            raise ValueError("Invalid value for `internal`, must not be `None`")  # noqa: E501

        self._internal = internal

    @property
    def io_size(self):
        """Gets the io_size of this NvmfSubsystem.  # noqa: E501


        :return: The io_size of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._io_size

    @io_size.setter
    def io_size(self, io_size):
        """Sets the io_size of this NvmfSubsystem.


        :param io_size: The io_size of this NvmfSubsystem.  # noqa: E501
        :type io_size: int
        """

        self._io_size = io_size

    @property
    def iops(self):
        """Gets the iops of this NvmfSubsystem.  # noqa: E501


        :return: The iops of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops

    @iops.setter
    def iops(self, iops):
        """Sets the iops of this NvmfSubsystem.


        :param iops: The iops of this NvmfSubsystem.  # noqa: E501
        :type iops: int
        """

        self._iops = iops

    @property
    def iops_max(self):
        """Gets the iops_max of this NvmfSubsystem.  # noqa: E501


        :return: The iops_max of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_max

    @iops_max.setter
    def iops_max(self, iops_max):
        """Sets the iops_max of this NvmfSubsystem.


        :param iops_max: The iops_max of this NvmfSubsystem.  # noqa: E501
        :type iops_max: int
        """

        self._iops_max = iops_max

    @property
    def iops_max_length(self):
        """Gets the iops_max_length of this NvmfSubsystem.  # noqa: E501


        :return: The iops_max_length of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_max_length

    @iops_max_length.setter
    def iops_max_length(self, iops_max_length):
        """Sets the iops_max_length of this NvmfSubsystem.


        :param iops_max_length: The iops_max_length of this NvmfSubsystem.  # noqa: E501
        :type iops_max_length: int
        """

        self._iops_max_length = iops_max_length

    @property
    def iops_rd(self):
        """Gets the iops_rd of this NvmfSubsystem.  # noqa: E501


        :return: The iops_rd of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_rd

    @iops_rd.setter
    def iops_rd(self, iops_rd):
        """Sets the iops_rd of this NvmfSubsystem.


        :param iops_rd: The iops_rd of this NvmfSubsystem.  # noqa: E501
        :type iops_rd: int
        """

        self._iops_rd = iops_rd

    @property
    def iops_rd_max(self):
        """Gets the iops_rd_max of this NvmfSubsystem.  # noqa: E501


        :return: The iops_rd_max of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_rd_max

    @iops_rd_max.setter
    def iops_rd_max(self, iops_rd_max):
        """Sets the iops_rd_max of this NvmfSubsystem.


        :param iops_rd_max: The iops_rd_max of this NvmfSubsystem.  # noqa: E501
        :type iops_rd_max: int
        """

        self._iops_rd_max = iops_rd_max

    @property
    def iops_rd_max_length(self):
        """Gets the iops_rd_max_length of this NvmfSubsystem.  # noqa: E501


        :return: The iops_rd_max_length of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_rd_max_length

    @iops_rd_max_length.setter
    def iops_rd_max_length(self, iops_rd_max_length):
        """Sets the iops_rd_max_length of this NvmfSubsystem.


        :param iops_rd_max_length: The iops_rd_max_length of this NvmfSubsystem.  # noqa: E501
        :type iops_rd_max_length: int
        """

        self._iops_rd_max_length = iops_rd_max_length

    @property
    def iops_wr(self):
        """Gets the iops_wr of this NvmfSubsystem.  # noqa: E501


        :return: The iops_wr of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_wr

    @iops_wr.setter
    def iops_wr(self, iops_wr):
        """Sets the iops_wr of this NvmfSubsystem.


        :param iops_wr: The iops_wr of this NvmfSubsystem.  # noqa: E501
        :type iops_wr: int
        """

        self._iops_wr = iops_wr

    @property
    def iops_wr_max(self):
        """Gets the iops_wr_max of this NvmfSubsystem.  # noqa: E501


        :return: The iops_wr_max of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_wr_max

    @iops_wr_max.setter
    def iops_wr_max(self, iops_wr_max):
        """Sets the iops_wr_max of this NvmfSubsystem.


        :param iops_wr_max: The iops_wr_max of this NvmfSubsystem.  # noqa: E501
        :type iops_wr_max: int
        """

        self._iops_wr_max = iops_wr_max

    @property
    def iops_wr_max_length(self):
        """Gets the iops_wr_max_length of this NvmfSubsystem.  # noqa: E501


        :return: The iops_wr_max_length of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._iops_wr_max_length

    @iops_wr_max_length.setter
    def iops_wr_max_length(self, iops_wr_max_length):
        """Sets the iops_wr_max_length of this NvmfSubsystem.


        :param iops_wr_max_length: The iops_wr_max_length of this NvmfSubsystem.  # noqa: E501
        :type iops_wr_max_length: int
        """

        self._iops_wr_max_length = iops_wr_max_length

    @property
    def ip_whitelist(self):
        """Gets the ip_whitelist of this NvmfSubsystem.  # noqa: E501


        :return: The ip_whitelist of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._ip_whitelist

    @ip_whitelist.setter
    def ip_whitelist(self, ip_whitelist):
        """Sets the ip_whitelist of this NvmfSubsystem.


        :param ip_whitelist: The ip_whitelist of this NvmfSubsystem.  # noqa: E501
        :type ip_whitelist: str
        """
        if self.local_vars_configuration.client_side_validation and ip_whitelist is None:  # noqa: E501
            raise ValueError("Invalid value for `ip_whitelist`, must not be `None`")  # noqa: E501

        self._ip_whitelist = ip_whitelist

    @property
    def labels(self):
        """Gets the labels of this NvmfSubsystem.  # noqa: E501


        :return: The labels of this NvmfSubsystem.  # noqa: E501
        :rtype: list[NestedLabel]
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this NvmfSubsystem.


        :param labels: The labels of this NvmfSubsystem.  # noqa: E501
        :type labels: list[NestedLabel]
        """

        self._labels = labels

    @property
    def local_id(self):
        """Gets the local_id of this NvmfSubsystem.  # noqa: E501


        :return: The local_id of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._local_id

    @local_id.setter
    def local_id(self, local_id):
        """Sets the local_id of this NvmfSubsystem.


        :param local_id: The local_id of this NvmfSubsystem.  # noqa: E501
        :type local_id: str
        """
        if self.local_vars_configuration.client_side_validation and local_id is None:  # noqa: E501
            raise ValueError("Invalid value for `local_id`, must not be `None`")  # noqa: E501

        self._local_id = local_id

    @property
    def name(self):
        """Gets the name of this NvmfSubsystem.  # noqa: E501


        :return: The name of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NvmfSubsystem.


        :param name: The name of this NvmfSubsystem.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def namespace_groups(self):
        """Gets the namespace_groups of this NvmfSubsystem.  # noqa: E501


        :return: The namespace_groups of this NvmfSubsystem.  # noqa: E501
        :rtype: list[NestedNamespaceGroup]
        """
        return self._namespace_groups

    @namespace_groups.setter
    def namespace_groups(self, namespace_groups):
        """Sets the namespace_groups of this NvmfSubsystem.


        :param namespace_groups: The namespace_groups of this NvmfSubsystem.  # noqa: E501
        :type namespace_groups: list[NestedNamespaceGroup]
        """

        self._namespace_groups = namespace_groups

    @property
    def namespaces(self):
        """Gets the namespaces of this NvmfSubsystem.  # noqa: E501


        :return: The namespaces of this NvmfSubsystem.  # noqa: E501
        :rtype: list[NestedNvmfNamespace]
        """
        return self._namespaces

    @namespaces.setter
    def namespaces(self, namespaces):
        """Sets the namespaces of this NvmfSubsystem.


        :param namespaces: The namespaces of this NvmfSubsystem.  # noqa: E501
        :type namespaces: list[NestedNvmfNamespace]
        """

        self._namespaces = namespaces

    @property
    def nqn_name(self):
        """Gets the nqn_name of this NvmfSubsystem.  # noqa: E501


        :return: The nqn_name of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._nqn_name

    @nqn_name.setter
    def nqn_name(self, nqn_name):
        """Sets the nqn_name of this NvmfSubsystem.


        :param nqn_name: The nqn_name of this NvmfSubsystem.  # noqa: E501
        :type nqn_name: str
        """
        if self.local_vars_configuration.client_side_validation and nqn_name is None:  # noqa: E501
            raise ValueError("Invalid value for `nqn_name`, must not be `None`")  # noqa: E501

        self._nqn_name = nqn_name

    @property
    def nqn_whitelist(self):
        """Gets the nqn_whitelist of this NvmfSubsystem.  # noqa: E501


        :return: The nqn_whitelist of this NvmfSubsystem.  # noqa: E501
        :rtype: str
        """
        return self._nqn_whitelist

    @nqn_whitelist.setter
    def nqn_whitelist(self, nqn_whitelist):
        """Sets the nqn_whitelist of this NvmfSubsystem.


        :param nqn_whitelist: The nqn_whitelist of this NvmfSubsystem.  # noqa: E501
        :type nqn_whitelist: str
        """
        if self.local_vars_configuration.client_side_validation and nqn_whitelist is None:  # noqa: E501
            raise ValueError("Invalid value for `nqn_whitelist`, must not be `None`")  # noqa: E501

        self._nqn_whitelist = nqn_whitelist

    @property
    def policy(self):
        """Gets the policy of this NvmfSubsystem.  # noqa: E501


        :return: The policy of this NvmfSubsystem.  # noqa: E501
        :rtype: NvmfSubsystemPolicyType
        """
        return self._policy

    @policy.setter
    def policy(self, policy):
        """Sets the policy of this NvmfSubsystem.


        :param policy: The policy of this NvmfSubsystem.  # noqa: E501
        :type policy: NvmfSubsystemPolicyType
        """
        if self.local_vars_configuration.client_side_validation and policy is None:  # noqa: E501
            raise ValueError("Invalid value for `policy`, must not be `None`")  # noqa: E501

        self._policy = policy

    @property
    def replica_num(self):
        """Gets the replica_num of this NvmfSubsystem.  # noqa: E501


        :return: The replica_num of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._replica_num

    @replica_num.setter
    def replica_num(self, replica_num):
        """Sets the replica_num of this NvmfSubsystem.


        :param replica_num: The replica_num of this NvmfSubsystem.  # noqa: E501
        :type replica_num: int
        """
        if self.local_vars_configuration.client_side_validation and replica_num is None:  # noqa: E501
            raise ValueError("Invalid value for `replica_num`, must not be `None`")  # noqa: E501

        self._replica_num = replica_num

    @property
    def stripe_num(self):
        """Gets the stripe_num of this NvmfSubsystem.  # noqa: E501


        :return: The stripe_num of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._stripe_num

    @stripe_num.setter
    def stripe_num(self, stripe_num):
        """Sets the stripe_num of this NvmfSubsystem.


        :param stripe_num: The stripe_num of this NvmfSubsystem.  # noqa: E501
        :type stripe_num: int
        """
        if self.local_vars_configuration.client_side_validation and stripe_num is None:  # noqa: E501
            raise ValueError("Invalid value for `stripe_num`, must not be `None`")  # noqa: E501

        self._stripe_num = stripe_num

    @property
    def stripe_size(self):
        """Gets the stripe_size of this NvmfSubsystem.  # noqa: E501


        :return: The stripe_size of this NvmfSubsystem.  # noqa: E501
        :rtype: int
        """
        return self._stripe_size

    @stripe_size.setter
    def stripe_size(self, stripe_size):
        """Sets the stripe_size of this NvmfSubsystem.


        :param stripe_size: The stripe_size of this NvmfSubsystem.  # noqa: E501
        :type stripe_size: int
        """
        if self.local_vars_configuration.client_side_validation and stripe_size is None:  # noqa: E501
            raise ValueError("Invalid value for `stripe_size`, must not be `None`")  # noqa: E501

        self._stripe_size = stripe_size

    @property
    def thin_provision(self):
        """Gets the thin_provision of this NvmfSubsystem.  # noqa: E501


        :return: The thin_provision of this NvmfSubsystem.  # noqa: E501
        :rtype: bool
        """
        return self._thin_provision

    @thin_provision.setter
    def thin_provision(self, thin_provision):
        """Sets the thin_provision of this NvmfSubsystem.


        :param thin_provision: The thin_provision of this NvmfSubsystem.  # noqa: E501
        :type thin_provision: bool
        """
        if self.local_vars_configuration.client_side_validation and thin_provision is None:  # noqa: E501
            raise ValueError("Invalid value for `thin_provision`, must not be `None`")  # noqa: E501

        self._thin_provision = thin_provision

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NvmfSubsystem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NvmfSubsystem):
            return True

        return self.to_dict() != other.to_dict()
